#
# A sample (boilerplate) selection menu item Ruby macro.
#
#

require('sketchup.rb')

module Author     ### <<<---<<< rename to YOUR toplevel author namespace

  module MyThing  ### <<<---<<< rename to YOUR plugin submodule name
  
    #{# MODULE VARS
    #
      @@do_my_thing_prompt = false
      
      @@error_message      = 'Nothing selected!'
      
      @@menutext           = 'Do My Thing'
      
      @@menutext_reset     = @@menutext.dup
    #
    #}#

    #{# MODULE FUNCTIONS
    #
      def self.error_message=(arg='Nothing selected!')
        # no arg resets the error string
        if arg.kind_of?(String)
          @@error_message = arg
        end
      end

      def self.menutext=(arg=@@menutext_reset.dup)
        # no arg resets the menutext
        if arg.kind_of?(String)
          @@menutext = arg
        end
      end

      def self.prompt(arg=true)
        @@do_my_thing_prompt = true
      end
      
      def self.prompt=(arg=false)
        # no arg turns messagebox OFF
        @@do_my_thing_prompt = ( arg ? true : false )
      end
    #
    #}#
    
    #{# Proxy class
    #
    class << self
    
      #{# PRIVATE METHODS
      #
        private
        
        def do_my_thing( selset )
          unless selset.empty?
            #
            # Act upon the entities in the selection set using
            # the Sketchup::Selection class iterator methods.
            #
            selset.each {|e|
              puts e.inspect
            }
            #
            # when done, clear the selection set
            selset.clear()
            # and make sure the SelectTool is still active
            Sketchup.active_model.select_tool(nil)
          else
            error_message()
          end
        end # def

        def error_message()
          # Output an error message to console unless
          # the global $VERBOSE is in "silent" mode (ie, nil.)
          puts(@@error_message) unless $VERBOSE.nil?
          # Optionally a popup messagebox, because the
          # status line gets redrawn as soon a mouse moves.
          if @@do_my_thing_prompt
            UI.messagebox(@@error_message)
          else
            Sketchup.status_text= @@error_message
          end
        end # def
      #
      #}#
    
    end # proxy class
    #
    #}#

    #{# CONTEXT MENU HANDLER
    #
    UI.add_context_menu_handler do |context_menu|
    
      selset = Sketchup.active_model.selection()
      unless selset.empty?
        # Add a menu item proc to the popup context menu
        # AND also (automatically,) the Selection submenu,
        # of the Edit menu.
        context_menu.add_item(@@menutext) { do_my_thing(selset) }
      else
        error_message()
      end
      
    end
    #
    #}#
  
    #{# RUN ONCE ON FIRST LOAD
    #
    unless file_loaded?(File.basename(__FILE__))

      #{# OTHER MENU COMMAND
      #
      # begin
        # @@top_menu = UI.menu('Plugins')
        # @@menu_item_id = @@top_menu.add_item('Selection: '<<@@menutext) {
          # do_my_thing( Sketchup.active_model.selection() )
        # }
        # @@top_menu.set_validation_proc(@@menu_item_id) {
          # Sketchup.active_model.selection().empty? ? MF_GRAYED : MF_ENABLED
        # }
      # end
      #
      #}#
      
      file_loaded(File.basename(__FILE__))

    end
    #
    #}#
  
  end # sub module

end # toplevel module 
